/*
   
 2  
   
:ViniPux
*/
#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <fun>
#include <fakemeta>

new bool:has_parachute
new para_ent[33]
new pFallSpeed
new g_iTotalMaps;
new mapname[32]
new g_sMapFile[512][32];
new cvar_use
new bool:dojump[33] = false
new jumpnum[33] = 0

public plugin_init()
{
	register_plugin("Parachute+jump", "2.0", "KRoT@L/JTP10181/ViniPux")
	pFallSpeed = register_cvar("parachute_fallspeed", "100")
 	register_forward(FM_PlayerPostThink, "PostThink")
	cvar_use = register_cvar("map_use_item","3")
	get_mapname(mapname, charsmax(mapname))
	load_maps();
}
stock load_maps()

{

        new filename[1024], filepath;

        get_configsdir(filename, sizeof filename - 1);

        format(filename, sizeof filename - 1, "%s/map_use.ini", filename);

        filepath = fopen(filename, "rt");

        if(filepath == 0)
                return;

        g_iTotalMaps = 0;

        while(!feof(filepath))
        {
                new buffer[32];

                fgets(filepath, buffer, sizeof buffer - 1);

                trim(buffer);

                if(!buffer[0])
                        continue;

                g_sMapFile[g_iTotalMaps] = buffer;

                ++g_iTotalMaps;

        }
        fclose(filepath);
        use_mp(g_iTotalMaps)

}
stock use_mp(g_iTotalMaps)
{
    new i;

    while(i <= g_iTotalMaps)
        {
                if(i == g_iTotalMaps)
                        break;

                if(strcmp(g_sMapFile[i], mapname) == 0)
                {
                        has_parachute = true;
                }
                ++i;
        }
}
public client_PreThink(id)
{
	if (!is_user_alive(id) || !has_parachute) return PLUGIN_CONTINUE
	if(get_pcvar_num(cvar_use) == 1 || get_pcvar_num(cvar_use) == 3)
	{
	new Float:fallspeed = get_pcvar_float(pFallSpeed) * -1.0
	new Float:frame

	new button = get_user_button(id)
	new oldbutton = get_user_oldbutton(id)
	new flags = get_entity_flags(id)

	if (para_ent[id] > 0 && (flags & FL_ONGROUND)) {

			if (get_user_gravity(id) == 0.1) set_user_gravity(id, 1.0)

			if (entity_get_int(para_ent[id],EV_INT_sequence) != 2) {
				entity_set_int(para_ent[id], EV_INT_sequence, 2)
				entity_set_int(para_ent[id], EV_INT_gaitsequence, 1)
				entity_set_float(para_ent[id], EV_FL_frame, 0.0)
				entity_set_float(para_ent[id], EV_FL_fuser1, 0.0)
				entity_set_float(para_ent[id], EV_FL_animtime, 0.0)
				entity_set_float(para_ent[id], EV_FL_framerate, 0.0)
				return PLUGIN_CONTINUE
			}

			frame = entity_get_float(para_ent[id],EV_FL_fuser1) + 2.0
			entity_set_float(para_ent[id],EV_FL_fuser1,frame)
			entity_set_float(para_ent[id],EV_FL_frame,frame)

			if (frame > 254.0) {
				remove_entity(para_ent[id])
				para_ent[id] = 0
			}
			return PLUGIN_CONTINUE

	}

	if (button & IN_USE) {

		new Float:velocity[3]
		entity_get_vector(id, EV_VEC_velocity, velocity)

		if (velocity[2] < 0.0) {

			if(para_ent[id] <= 0) {
				para_ent[id] = create_entity("info_target")
				if(para_ent[id] > 0) {
					entity_set_string(para_ent[id],EV_SZ_classname,"parachute")
					entity_set_edict(para_ent[id], EV_ENT_aiment, id)
					entity_set_edict(para_ent[id], EV_ENT_owner, id)
					entity_set_int(para_ent[id], EV_INT_movetype, MOVETYPE_FOLLOW)
					//entity_set_model(para_ent[id], "models/parachute.mdl")
					entity_set_int(para_ent[id], EV_INT_sequence, 0)
					entity_set_int(para_ent[id], EV_INT_gaitsequence, 1)
					entity_set_float(para_ent[id], EV_FL_frame, 0.0)
					entity_set_float(para_ent[id], EV_FL_fuser1, 0.0)
				}
			}

			if (para_ent[id] > 0) {

				entity_set_int(id, EV_INT_sequence, 3)
				entity_set_int(id, EV_INT_gaitsequence, 1)
				entity_set_float(id, EV_FL_frame, 1.0)
				entity_set_float(id, EV_FL_framerate, 1.0)
				set_user_gravity(id, 0.1)

				velocity[2] = (velocity[2] + 40.0 < fallspeed) ? velocity[2] + 40.0 : fallspeed
				entity_set_vector(id, EV_VEC_velocity, velocity)

				if (entity_get_int(para_ent[id],EV_INT_sequence) == 0) {

					frame = entity_get_float(para_ent[id],EV_FL_fuser1) + 1.0
					entity_set_float(para_ent[id],EV_FL_fuser1,frame)
					entity_set_float(para_ent[id],EV_FL_frame,frame)

					if (frame > 100.0) {
						entity_set_float(para_ent[id], EV_FL_animtime, 0.0)
						entity_set_float(para_ent[id], EV_FL_framerate, 0.4)
						entity_set_int(para_ent[id], EV_INT_sequence, 1)
						entity_set_int(para_ent[id], EV_INT_gaitsequence, 1)
						entity_set_float(para_ent[id], EV_FL_frame, 0.0)
						entity_set_float(para_ent[id], EV_FL_fuser1, 0.0)
					}
				}
			}
		}
		else if (para_ent[id] > 0) {
			remove_entity(para_ent[id])
			set_user_gravity(id, 1.0)
			para_ent[id] = 0
		}
	}
	else if ((oldbutton & IN_USE) && para_ent[id] > 0 ) {
		remove_entity(para_ent[id])
		set_user_gravity(id, 1.0)
		para_ent[id] = 0
	}
	}
	if(get_pcvar_num(cvar_use) == 2 || get_pcvar_num(cvar_use) == 3)
	{
	
	new nbut = pev(id, pev_button)
	new obut = pev(id, pev_oldbuttons)
	if((nbut & IN_JUMP) && !(pev(id, pev_flags) & FL_ONGROUND) && !(obut & IN_JUMP))
        {
	if(jumpnum[id] < 1)
                {
                        dojump[id] = true
                        jumpnum[id]++
                        return PLUGIN_CONTINUE

                }
        }

	if((pev(id, pev_flags) & FL_ONGROUND))
	{
                jumpnum[id] = 0
                return PLUGIN_CONTINUE
	}

	}
	return PLUGIN_CONTINUE
}
public PostThink(id)

{
    if(has_parachute)  
 {
        if(!is_user_alive(id)) return PLUGIN_CONTINUE
        if(dojump[id] == true)
        {
                new Float:velocity[3]  
                pev(id, pev_velocity, velocity)
                velocity[2] = random_float(295.0,305.0)
                set_pev(id, pev_velocity, velocity)
                dojump[id] = false
                return PLUGIN_CONTINUE
        }   
 }
    return PLUGIN_CONTINUE

}
